﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using System.Web.Hosting;
using HLWebPluginHost.PluginLib;
using System.Diagnostics;

namespace HLWebPluginHost {
  // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
  // visit http://go.microsoft.com/?LinkId=9394801

  public class MvcApplication : System.Web.HttpApplication {
    public static void RegisterRoutes(RouteCollection routes) {
      routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

      routes.MapRoute(
          "Default",
          "{controller}/{action}/{id}",
          new { controller = "Home", action = "Index", id = UrlParameter.Optional },
          new string[] { "HLWebPluginHost.Controllers" }  // <------------New string array with namespaces to search
      );

    }

    protected void Application_Start() {
      AreaRegistration.RegisterAllAreas();

      // This just tells the framework to use our custom AssemblyResourceProvider when accessing files.
      HostingEnvironment.RegisterVirtualPathProvider(new AssemblyResourceProvider());
      
      // Initializes plugins and views
      PluginHelper.InitializePluginsAndLoadViewLocations();

      RegisterRoutes(RouteTable.Routes);
    }
  }
}